;  -    ZIP-    St Reader
;Copyright () 2004-2007,  , -.
;    Zlib ( Jean-loup Gailly  Mark Adler).

.386
locals
jumps
.model flat,stdcall

include win32.inc
include str_arch.inc

INCLUDELIB GDI32.lib
INCLUDELIB KERNEL32.lib
INCLUDELIB USER32.lib
INCLUDELIB zlibwapi.lib


;extrn	:PROC
;extrn	:PROC
;extrn	:PROC
;extrn	:PROC
extrn	MessageBoxA:PROC
extrn	OemToCharA:PROC
extrn	FreeLibrary:PROC
extrn	GetProcAddress:PROC
extrn	CharToOemA:PROC
extrn	LocalFileTimeToFileTime:PROC
extrn	GetTimeFormatA:PROC
extrn	GetDateFormatA:PROC
extrn	FileTimeToSystemTime:PROC
extrn	DosDateTimeToFileTime:PROC
extrn	FileTimeToLocalFileTime:PROC
extrn	CheckDlgButton:PROC
extrn	CloseHandle:PROC
extrn	CreateFileA:PROC
extrn	DialogBoxParamA:PROC
extrn	EndDialog:PROC
extrn	FindClose:PROC
extrn	FindFirstFileA:PROC
extrn	FindNextFileA:PROC
extrn	GetDlgItemTextA:PROC
extrn	GetFileSize:PROC
extrn	GetLastError:PROC
extrn	GlobalAlloc:PROC
extrn	GlobalFree:PROC
extrn	IsDlgButtonChecked:PROC
extrn	LoadLibraryA:PROC
extrn	LoadStringA:PROC
extrn	lstrcatA:PROC
extrn	lstrcmpA:PROC
extrn	lstrcmpiA:PROC
extrn	lstrcpyA:PROC
extrn	lstrlenA:PROC
extrn	ReadFile:PROC
extrn	SendDlgItemMessageA:PROC
extrn	SetDlgItemTextA:PROC
extrn	SetWindowTextA:PROC

.code

;-----------------------------------------------------------------------------

DLL_Entry proc uses ebx edi esi, hinstDLL:dword, fdwReason:dword, lpvReserved:dword

.data

plugin_hInst dd 0
zlib_dll_name db "zlibwapi.dll",0
zlib_dll_handle dd 0

.data?

zlib_dll_name_buffer db MAX_PATH dup(?)

.code
	cmp fdwReason,DLL_PROCESS_ATTACH
	je @@dll_process_attach
	cmp fdwReason,DLL_PROCESS_DETACH
	je @@dll_process_detach

	jmp @@exit_dll_entry

@@dll_process_attach:
	push hinstDLL
	pop plugin_hInst

	jmp @@exit_dll_entry

@@dll_process_detach:
	jmp @@exit_dll_entry

@@exit_dll_entry:

	mov eax,true

@@exit_proc:
	ret

DLL_Entry endp


;+++++++++++++++++++++


	public St_Reader_Plugin_Entry
St_Reader_Plugin_Entry proc uses ebx ecx edi esi

;   St_Reader_Unpacker_Structure

;: eax<>0 -    St_Reader_Unpacker_Structure, 0 -   


.data

Unpacker_Data_Struct St_Reader_Unpacker_Structure <0>

archive_files_number dd 0
zip_pattern db "*.zip",0
St_Reader_plugin_text db "St Reader unpacker",0

.code

	mov Unpacker_Data_Struct.st_plugin_size, St_Reader_Unpacker_Structure_size	; 
	mov Unpacker_Data_Struct.st_plugin_string,offset St_Reader_plugin_text		;  "St Reader unpacker"
	mov Unpacker_Data_Struct.st_plugin_ver,10					;  = 1.0
	mov Unpacker_Data_Struct.st_plugin_format_pattern_address,offset zip_pattern		;         
	mov Unpacker_Data_Struct.st_plugin_converter_unicode_flag,0				;ANSI
	mov Unpacker_Data_Struct.st_unpacker_check_archive_proc_address,offset St_Reader_Unpacker_Check_Archive_Type	;    
	mov Unpacker_Data_Struct.st_unpacker_files_list_proc_address,offset St_Reader_Unpacker_Get_Files_List	;            St_Reader_Unpacker_File_Structure
	mov Unpacker_Data_Struct.st_unpacker_file_data_proc_address,offset St_Reader_Unpacker_Get_File_Data	;            St_Reader_Unpacker_File_Structure
	mov Unpacker_Data_Struct.st_unpacker_file_unpack_proc_address,offset St_Reader_Unpacker_File_Unpack	;    
	mov Unpacker_Data_Struct.st_plugin_string_proc_address,offset Plugin_text_strings		;       lng-   

;	mov Unpacker_Data_Struct.st_plugin_reserved1,0
;	mov Unpacker_Data_Struct.st_plugin_reserved2,0
;	mov Unpacker_Data_Struct.st_plugin_reserved3,0
;	mov Unpacker_Data_Struct.st_plugin_reserved4,0
;	mov Unpacker_Data_Struct.st_plugin_reserved5,0

	mov eax,offset Unpacker_Data_Struct

	ret

St_Reader_Plugin_Entry endp


;+++++++++++++++++++++

St_Reader_Unpacker_Check_Archive_Type proc uses ebx ecx edx edi esi, archive_file_path_address:dword, parent_hwnd:dword
	
local @@file_handle:dword, @@file_size:dword

;      ZIP 

;: archive_file_path_address -      
;parent_hwnd - hwnd         

;: eax=0 -    ,   
;eax=1 -   ,   
;eax=-1 -   

.data

current_parent_hwnd dd 0

.data?

zip_file_signature_buffer db 23 dup(?)

.code

	mov eax,parent_hwnd
	mov current_parent_hwnd,eax

	call CreateFileA, archive_file_path_address, GENERIC_READ, FILE_SHARE_READ, L 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, L 0

	cmp eax,INVALID_HANDLE_VALUE
	je @@it_is_not_zip_file

	mov @@file_handle,eax

	call GetFileSize, @@file_handle, lpFileSizeHigh

	mov @@file_size,eax
	cmp @@file_size,22	;ZIP      22 
	jb @@it_is_not_zip_file 

;  zip-
	call ReadFile, @@file_handle, offset zip_file_signature_buffer, 22, offset read_written_byte_number, L 0

	call CloseHandle, @@file_handle

	cmp read_written_byte_number,22	; ZIP  = 22 
	jne @@error_file_reading

	mov eax,04034b50h	;local file header signature
	cmp dword ptr zip_file_signature_buffer,eax
	je @@it_is_zip_file

	mov eax,06054b50h	;end of central dir signature
	cmp dword ptr zip_file_signature_buffer,eax
	je @@it_is_zip_file

	jmp @@it_is_not_zip_file

@@error_file_reading:
	mov eax,-1
	jmp @@exit_proc

@@it_is_zip_file:
	mov eax,1
	jmp @@exit_proc

@@it_is_not_zip_file:
	mov eax,0

@@exit_proc:
	ret

St_Reader_Unpacker_Check_Archive_Type endp

;+++++++++++++++++++++

St_Reader_Unpacker_Get_Files_List proc uses ebx ecx edx edi esi, archive_file_path_address:dword, archive_files_list_address:dword, parent_hwnd:dword
	
local @@dir_level:dword

;                 
;.
;              St_Reader_Unpacker_File_Structure
;( str_arch.inc)       FILETIME   LocalFileTime,    
;,          (level,     
;     ),  (, ),         
;(   ZIP     "/"     Windows "\", 
;h DOS   ANSI).

;: archive_file_path_address -      
;: c:\dir1\dir2\archiv.zip

;archive_files_list_address -             
;parent_hwnd - hwnd         

;: eax=0 -      , eax<>0 -      

extrn            unzLocateFile:proc
extrn            unzOpenCurrentFile:proc
extrn            unzOpenCurrentFilePassword:proc
extrn            unzReadCurrentFile:proc
extrn            unzCloseCurrentFile:proc
extrn            unzOpen:proc
extrn            unzClose:proc
extrn            unzGetGlobalInfo:proc
extrn            unzGoToFirstFile:proc
extrn            unzGoToNextFile:proc
extrn            unzGetCurrentFileInfo:proc

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

unz_global_info struc
	number_entry	dd ?	;total number of entries in  the central dir on this disk
	size_comment	dd ?	;size of the global comment of the zipfile
unz_global_info ends

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

tm_unz struc
	tm_sec	dd ?	;seconds after the minute - [0,59]
	tm_min	dd ?	;minutes after the hour - [0,59]
	tm_hour	dd ?	;hours since midnight - [0,23]
	tm_mday	dd ?	;day of the month - [1,31]
	tm_mon	dd ?	;months since January - [0,11]
	tm_year	dd ?	;years - [1980..2044]
tm_unz ends

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

unz_file_info struc
    version		dd ?	;version made by                 2 bytes
    version_needed		dd ?	;version needed to extract       2 bytes
    flag			dd ?	;general purpose bit flag        2 bytes
    compression_method	dd ?	;compression method              2 bytes
    dosDate		dd ?	;last mod file date in Dos fmt   4 bytes
    crc			dd ?	;crc-32                          4 bytes
    compressed_size		dd ?	;compressed size                 4 bytes
    uncompressed_size	dd ?	;uncompressed size               4 bytes
    size_filename		dd ?	;filename length                 2 bytes
    size_file_extra		dd ?	;extra field length              2 bytes
    size_file_comment	dd ?	;file comment length             2 bytes
    disk_num_start		dd ?	;disk number start               2 bytes
    internal_fa		dd ?	;internal file attributes        2 bytes
    external_fa		dd ?	;external file attributes        4 bytes
    tmu_date 		tm_unz <>	;
unz_file_info ends

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

UNZ_OK			= 0
UNZ_END_OF_LIST_OF_FILE	= -100
Z_ERRNO        		= -1
UNZ_ERRNO			= Z_ERRNO
UNZ_EOF			= 0
UNZ_PARAMERROR		= -102
UNZ_BADZIPFILE		= -103
UNZ_INTERNALERROR		= -104
UNZ_CRCERROR		= -105

.data

zip_file_handle dd 0
zip_file_global_info unz_global_info <0>
zip_file_file_info unz_file_info <0>
archive_files_list_buffer_address dd 0
file_time FILETIME <0>
local_file_time FILETIME <0>
file_system_time SYSTEMTIME <0>

.data?

FORMATTED_FILE_DATE DD 20 DUP(?)	;      
FORMATTED_FILE_TIME DD 10 DUP(?)	;      

.code

	mov eax,parent_hwnd
	mov current_parent_hwnd,eax

	call unzOpen, archive_file_path_address

	mov zip_file_handle,eax

;   ZIP 
	call unzGetGlobalInfo, zip_file_handle, offset zip_file_global_info

	mov eax,zip_file_global_info.number_entry
	mov archive_files_number,eax		;   

	cmp eax,0
	je @@no_files_more_in_zip

;         
	mov ecx,St_Reader_Unpacker_File_Structure_size

	mul ecx

	call GlobalAlloc, GMEM_FIXED, eax

	mov ebx,archive_files_list_address
	mov archive_files_list_buffer_address,eax
	mov [ebx],eax	;             

;       
	call unzGoToFirstFile, zip_file_handle

	mov esi,archive_files_list_buffer_address
	mov ebx,0		;      
	lea ecx,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

;        
	call unzGetCurrentFileInfo, zip_file_handle, offset zip_file_file_info, ecx, MAX_PATH, 0, 0, 0, 0

;       DOS   LocalFileTime
	xor eax,eax
	xor edx,edx
	mov ax,word ptr zip_file_file_info.dosDate
	mov dx,word ptr zip_file_file_info.dosDate+2


	call DosDateTimeToFileTime, edx, eax, offset file_time

	call FileTimeToLocalFileTime, offset file_time, offset local_file_time

;       LocalFileTime        
	mov ecx,offset local_file_time
	mov eax,[ecx]
	mov dword ptr [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_date,eax
	mov eax,[ecx+4]
	mov dword ptr [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_date+4,eax

;          
	mov eax,zip_file_file_info.uncompressed_size
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_size,eax


;     "\"     
	lea edi,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call lstrlenA, edi

	add edi,eax
	dec edi
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,0
	cmp byte ptr [edi],"/"
	je @@it_is_directory

	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1

@@it_is_directory:
;       
	lea edi,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call lstrlenA, edi

	mov ecx,eax
	mov @@dir_level,0

@@loop_count_dir_level:
	cmp byte ptr [edi],"/"
	jne @@it_is_not_slash

	mov byte ptr [edi],"\"
	inc @@dir_level

@@it_is_not_slash:
	inc edi
	dec ecx
	jne @@loop_count_dir_level

	cmp [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1
	je @@it_is_file_during_dir_level

	dec @@dir_level

@@it_is_file_during_dir_level:
;                
	mov eax,@@dir_level
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_dir_level,eax

;              
	lea eax,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call OemToCharA, eax, eax	; ZIP    DOS-,   ANSI

	add ebx,St_Reader_Unpacker_File_Structure_size

@@loop_getting_files_list_from_archive:
;       
	call unzGoToNextFile, zip_file_handle

	cmp eax,UNZ_END_OF_LIST_OF_FILE
	je @@no_files_more_in_zip

;        
	lea ecx,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call unzGetCurrentFileInfo, zip_file_handle, offset zip_file_file_info, ecx, MAX_PATH, 0, 0, 0, 0

;       DOS   LocalFileTime
	xor eax,eax
	xor edx,edx
	mov ax,word ptr zip_file_file_info.dosDate
	mov dx,word ptr zip_file_file_info.dosDate+2


	call DosDateTimeToFileTime, edx, eax, offset file_time

	call FileTimeToLocalFileTime, offset file_time, offset local_file_time

;       LocalFileTime        
	mov ecx,offset local_file_time
	mov eax,[ecx]
	mov dword ptr [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_date,eax
	mov eax,[ecx+4]
	mov dword ptr [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_date+4,eax

;          
	mov eax,zip_file_file_info.uncompressed_size
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_size,eax

;     "\"     
	lea edi,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call lstrlenA, edi

	add edi,eax
	dec edi
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,0
	cmp byte ptr [edi],"/"
	je @@it_is_directory2

	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1

@@it_is_directory2:
;       
	lea edi,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call lstrlenA, edi

	mov ecx,eax
	mov @@dir_level,0

@@loop_count_dir_level2:
	cmp byte ptr [edi],"/"
	jne @@it_is_not_slash2

	mov byte ptr [edi],"\"
	inc @@dir_level

@@it_is_not_slash2:
	inc edi
	dec ecx
	jne @@loop_count_dir_level2

	cmp [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1
	je @@it_is_file_during_dir_level2

	dec @@dir_level

@@it_is_file_during_dir_level2:
;                
	mov eax,@@dir_level
	mov [esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_dir_level,eax

;              
	lea eax,[esi+ebx+St_Reader_Unpacker_File_Structure].st_unpacker_file_name

	call OemToCharA, eax, eax

	add ebx,St_Reader_Unpacker_File_Structure_size

	jmp @@loop_getting_files_list_from_archive

@@no_files_more_in_zip:
	call unzClose, zip_file_handle

@@exit_proc:
;       
	mov eax,archive_files_number

	ret

St_Reader_Unpacker_Get_Files_List endp

;+++++++++++++++++++++

St_Reader_Unpacker_Get_File_Data proc uses ebx ecx edx edi esi, archive_file_path_address:dword, unpacked_file_structure_address:dword, parent_hwnd:dword

local @@file_path_buffer:dword:MAX_PATH/2, @@packed_file_path_address:dword
local @@zip_file_handle:dword, @@archive_opening_file_size:dword, @@file_buffer_address:dword
local @@dir_level:dword

;       
;             St_Reader_Unpacker_File_Structure
;( str_arch.inc)       FILETIME   LocalFileTime,    
;,          (level,     
;     ),  (, ),   ,      .

;: 
;archive_file_path_address -         (           "/"  "\")
;: c:\dir1\dir2\archiv.zip/dir_in_archiv1\dir_in_archiv1\file_in_archiv.txt

;unpacked_file_structure_address -         
;parent_hwnd - hwnd         

;: eax=true,   eax=false

	mov eax,parent_hwnd
	mov current_parent_hwnd,eax

	lea eax,@@file_path_buffer
	mov esi,eax

	call lstrcpyA, eax, archive_file_path_address

@@loop_devide_full_path_to_archive_and_packed_file:
;                

	cmp byte ptr [esi],0
;	je @@error_loop_devide_full_path_to_archive_and_packed_file
	cmp byte ptr [esi],"/"	;"/"          
	je @@exit_loop_devide_full_path_to_archive_and_packed_file

	inc esi
	jmp @@loop_devide_full_path_to_archive_and_packed_file
	
@@exit_loop_devide_full_path_to_archive_and_packed_file:

	mov byte ptr [esi],0
	inc esi
	mov @@packed_file_path_address,esi

@@loop_change_slashes:
;  "\"      ,   ,     ZIP  "/"
	cmp byte ptr [esi],0
	je @@exit_loop_change_slashes
	cmp byte ptr [esi],"\"
	jne @@next_loop_change_slashes

	mov byte ptr [esi],"/"

@@next_loop_change_slashes:
	inc esi
	jmp @@loop_change_slashes

@@exit_loop_change_slashes:
	mov esi,unpacked_file_structure_address
	lea ecx,@@file_path_buffer

	call unzOpen, ecx

	mov @@zip_file_handle,eax

; ZIP    DOS-,   ANSI  OEM
	call CharToOemA, @@packed_file_path_address, @@packed_file_path_address

;    
	call unzLocateFile, @@zip_file_handle, @@packed_file_path_address, 2

	cmp eax,UNZ_END_OF_LIST_OF_FILE
	jne @@file_is_located

	mov eax,false	;      ,      FALSE
	jmp @@exit_proc

@@file_is_located:
;      
	call unzGetCurrentFileInfo, @@zip_file_handle, offset zip_file_file_info, 0, 0, 0, 0, 0, 0

;       DOS   LocalFileTime
	xor eax,eax
	xor edx,edx
	mov ax,word ptr zip_file_file_info.dosDate
	mov dx,word ptr zip_file_file_info.dosDate+2

	call DosDateTimeToFileTime, edx, eax, offset file_time

	call FileTimeToLocalFileTime, offset file_time, offset local_file_time

;       LocalFileTime       
	mov ecx,offset local_file_time
	mov eax,[ecx]
	mov dword ptr [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_date,eax
	mov eax,[ecx+4]
	mov dword ptr [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_date+4,eax

;         
	mov eax,zip_file_file_info.uncompressed_size
	mov [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_size,eax

	mov [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1

;       
	mov edi,archive_file_path_address

	call lstrlenA, edi

	mov ecx,eax
	mov @@dir_level,0

@@loop_search_archive_dir:
	cmp byte ptr [edi],"/"
	je @@loop_count_dir_level

	inc edi
	dec ecx
	jne @@loop_search_archive_dir

@@loop_count_dir_level:
	cmp byte ptr [edi],"\"
	jne @@next_loop_count_dir_level

	inc @@dir_level

@@next_loop_count_dir_level:
	inc edi
	dec ecx
	jne @@loop_count_dir_level

	cmp [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_type,1
	je @@it_is_file_during_dir_level

	dec @@dir_level

@@it_is_file_during_dir_level:
;            
	mov eax,@@dir_level
	mov [esi+St_Reader_Unpacker_File_Structure].st_unpacker_file_dir_level,eax

	call unzClose, @@zip_file_handle

	mov eax,true

@@exit_proc:
	ret

St_Reader_Unpacker_Get_File_Data endp


;+++++++++++++++++++++

St_Reader_Unpacker_File_Unpack proc uses ebx ecx edx edi esi, archive_file_path_address:dword, archive_file_buffer_address:dword, parent_hwnd:dword

local @@file_path_buffer:dword:MAX_PATH/2, @@packed_file_path_address:dword
local @@zip_file_handle:dword, @@archive_opening_file_size:dword, @@file_buffer_address:dword

;     ZIP 

;: 
;archive_file_path_address -         (           "/")
;: c:\dir1\dir2\archiv.zip/dir_in_archiv1\dir_in_archiv1\file_in_archiv.txt

;archive_file_buffer_address -         
;parent_hwnd - hwnd         

;: eax=  ,   eax=-1


IDD_PASSWORD = 500


	mov eax,parent_hwnd
	mov current_parent_hwnd,eax

	lea eax,@@file_path_buffer
	mov esi,eax

	call lstrcpyA, eax, archive_file_path_address

@@loop_devide_full_path_to_archive_and_packed_file:
;                

	cmp byte ptr [esi],0
;	je @@error_loop_devide_full_path_to_archive_and_packed_file
	cmp byte ptr [esi],"/"	;"/"          
	je @@exit_loop_devide_full_path_to_archive_and_packed_file

	inc esi
	jmp @@loop_devide_full_path_to_archive_and_packed_file
	
@@exit_loop_devide_full_path_to_archive_and_packed_file:

	mov byte ptr [esi],0
	inc esi
	mov @@packed_file_path_address,esi

@@loop_change_slashes:
;  "\"      ,   ,     ZIP  "/"
	cmp byte ptr [esi],0
	je @@exit_loop_change_slashes
	cmp byte ptr [esi],"\"
	jne @@next_loop_change_slashes

	mov byte ptr [esi],"/"

@@next_loop_change_slashes:
	inc esi
	jmp @@loop_change_slashes

@@exit_loop_change_slashes:
	lea ecx,@@file_path_buffer

	call unzOpen, ecx

	mov @@zip_file_handle,eax

; ZIP    DOS-,   ANSI  OEM
	call CharToOemA, @@packed_file_path_address, @@packed_file_path_address

;    
	call unzLocateFile, @@zip_file_handle, @@packed_file_path_address, 2

	cmp eax,UNZ_END_OF_LIST_OF_FILE
	jne @@file_is_located

	mov eax,-1	;      ,      -1
	jmp @@exit_proc

@@file_is_located:
;      
	call unzGetCurrentFileInfo, @@zip_file_handle, offset zip_file_file_info, 0, 0, 0, 0, 0, 0

;    
	mov eax,zip_file_file_info.uncompressed_size
	mov @@archive_opening_file_size,eax

;      
	cmp @@archive_opening_file_size,10000	;     1401    GlobalFree     ,      
	jae @@more_10000

	call GlobalAlloc, GMEM_FIXED, 10000
	
	jmp @@save_buffer_address

@@more_10000:
	call GlobalAlloc, GMEM_FIXED, @@archive_opening_file_size

@@save_buffer_address:
	mov @@file_buffer_address,eax

;  ,     
	test zip_file_file_info.flag,1
	jnz @@open_file_with_password

;    ,     
	call unzOpenCurrentFile, @@zip_file_handle

	jmp @@read_file_from_archive

@@open_file_with_password:
;    ,               
	call GlobalAlloc, GMEM_FIXED, 10000

	mov ebx,eax

	call DialogBoxParamA, plugin_hInst, IDD_PASSWORD, parent_hwnd, offset Password_dlg_proc, ebx

	cmp eax,true
	je @@open_file_in_archive_with_password

;   ,           
	call GlobalFree, ebx

	jmp @@file_is_not_opened

@@open_file_in_archive_with_password:
;    ,     
	call unzOpenCurrentFilePassword, @@zip_file_handle, ebx

;     0
	mov edi,ebx
	mov ecx,100
	xor eax,eax

rep	stosb

;     
	call GlobalFree, ebx

@@read_file_from_archive:
;   
	call unzReadCurrentFile, @@zip_file_handle, @@file_buffer_address, @@archive_opening_file_size

	cmp eax,0
	jge @@file_is_unpacked

;    ,     
	call Error_message, parent_hwnd, 1025, 0, 0, 0, 0, 1024, 0, MB_OK+MB_ICONEXCLAMATION

@@file_is_not_opened:
;    
	call unzCloseCurrentFile, @@zip_file_handle

	call unzClose, @@zip_file_handle

	mov eax,-1
	jmp @@exit_proc

@@file_is_unpacked:
;  
	call unzCloseCurrentFile, @@zip_file_handle

	call unzClose, @@zip_file_handle

;       ,   
	mov ebx,archive_file_buffer_address
	mov eax,@@file_buffer_address
	mov [ebx],eax

;      
	mov eax,@@archive_opening_file_size

@@exit_proc:
	ret

St_Reader_Unpacker_File_Unpack endp

;+++++++++++++++++++++

Password_dlg_proc PROC uses ebx ecx edx edi esi, HDLG:DWORD, WMSG:DWORD, WPARAM:DWORD, LPARAM:DWORD

;         

IDC_PASSWORD_LABEL = 200

.data

password_buffer_address dd 0
password_dlg_language_strings_list dd -1, 1020, IDC_PASSWORD_LABEL, 1021, IDCANCEL, 1022, 0

.code
	CMP [WMSG],WM_INITDIALOG
	JE @@INITIALIZ_DLGPROC
	CMP [WMSG],WM_COMMAND
	JE @@DLGPROC_COMMAND_MESSAGE

	JMP @@FALSE_DLGPROC

@@INITIALIZ_DLGPROC:
;     
	call Load_dialog_language, HDLG, offset password_dlg_language_strings_list

	mov eax,[LPARAM]
	mov password_buffer_address,eax

;   = 100 
	CALL SendDlgItemMessageA, HDLG, 100, EM_SETLIMITTEXT, MAX_PATH, 0

@@EXIT_INITIALIZ_DLGPROC:
	JMP @@TRUE_DLGPROC

@@DLGPROC_COMMAND_MESSAGE:
	CMP WORD PTR [WPARAM],IDCANCEL
	JE @@BUTTON_CANCEL_PRESSED
	CMP WORD PTR [WPARAM],IDOK
	JE @@BUTTON_OK_PRESSED

	JMP @@FALSE_DLGPROC

@@BUTTON_OK_PRESSED:
;  
	call GetDlgItemTextA, HDLG, 100, password_buffer_address, MAX_PATH

	cmp eax,0
	jne @@EXIT_BUTTON_OK_PRESSED

;   = 0,     
	call Error_message, HDLG, 1023, 0, 0, 0, 0, 1024, 0, MB_OK+MB_ICONEXCLAMATION

	jmp @@TRUE_DLGPROC

@@EXIT_BUTTON_OK_PRESSED:
	call EndDialog, HDLG, TRUE

	JMP @@TRUE_DLGPROC

@@BUTTON_CANCEL_PRESSED:
	call EndDialog, HDLG, FALSE

	jmp @@TRUE_DLGPROC

@@FALSE_DLGPROC:
	mov eax,FALSE
	jmp @@EXIT_DLG_PROC

@@TRUE_DLGPROC:
	mov eax,TRUE

@@EXIT_DLG_PROC:
	ret

Password_dlg_proc ENDP

;+++++++++++++++++++++

Load_dialog_language proc uses ebx ecx edx esi edi, current_hdlg:dword, strings_numbers_address:dword

;       

;:
;      strings_numbers_address -     :          
;          lng-,  2             
;      (      -1); 0     -     


.data?

message_buffer db 1025 dup(?)

.code
	mov esi,strings_numbers_address
	mov ebx,[esi+4]	;     LNG-    

	mov edi,Unpacker_Data_Struct.st_plugin_language_code_address
	cmp dword ptr [edi],0	;0-  , <>0 -  
	je @@open_window_text_eng

;   LNG-     
	call Open_language_file

;     
	cmp local_language_code,0	; =0  LNG-            -
	je @@open_window_text_eng

;     
	mov current_language_file_buffer_address,eax

	call Load_language_string, current_language_file_buffer_address, ebx, offset message_buffer, 1024

	cmp eax,0
	je @@open_window_text_eng
	jmp @@set_window_text

@@open_window_text_eng:
;    
	call LoadStringA, plugin_hInst, ebx, offset message_buffer, 1024

@@set_window_text:
;   
	call SetWindowTextA, current_hdlg, offset message_buffer


;     
	add esi,8

@@loop_set_items_texts:
	cmp dword ptr [esi],0	;      0     strings_numbers_address
	je @@exit_loop

	mov ebx,[esi+4]

	mov edi,Unpacker_Data_Struct.st_plugin_language_code_address
	cmp dword ptr [edi],0	;0-  , <>0 -  
	je @@open_item_text_eng

	cmp local_language_code,0	; =0  LNG-            -
	je @@open_item_text_eng

	call Load_language_string, current_language_file_buffer_address, ebx, offset message_buffer, 1024

	cmp eax,0
	je @@open_item_text_eng
	jmp @@set_item_text

@@open_item_text_eng:
	call LoadStringA, plugin_hInst, ebx, offset message_buffer, 1024

@@set_item_text:
;     
	mov ebx,[esi]
	call SetDlgItemTextA, current_hdlg, ebx, offset message_buffer

	add esi,8
	jmp @@loop_set_items_texts

@@exit_loop:
	cmp current_language_file_buffer_address,0
	je @@exit_proc

	call GlobalFree, current_language_file_buffer_address

	mov current_language_file_buffer_address,0

@@exit_proc:
	ret

Load_dialog_language endp

;+++++++++++++++++++++

Plugin_text_strings proc uses ebx edi esi, current_language:dword, language_file_buffer_address:dword, \
	string_number:dword, string_buffer_address:dword, string_buffer_size:dword

;            

;: current_language: 0-, <>0- 
;      language_file_buffer_address -  -      ,
;      string_number=1, 2  3 (1- , 2- , 3-      Open,
;      50   -   ),
;      string_buffer_address=    ,
;      string_buffer_size=      
;: eax=0 -  , eax<>0 -    (   )

.data

current_language_file_buffer_address dd 0

.code

	mov ebx,string_buffer_address
	mov byte ptr [ebx],0

	cmp string_number,1		; "St Reader ZIP - from St"
	je @@getting_string
	cmp string_number,2		; "- ZIP    St Reader.\r\nCopyright(c) 2007   . -."
	je @@getting_string

	mov eax,0
	jmp @@exit_proc

@@getting_string:
	mov ebx,string_number
	add ebx,1010	;        lng-

	cmp current_language,0
	jne @@it_is_not_english_language
	
@@it_is_english_language:
	call LoadStringA, plugin_hInst, ebx, string_buffer_address, string_buffer_size

	jmp @@exit_proc

@@it_is_not_english_language:
	call Open_language_file

	cmp local_language_code,0	;LNG-        
	je @@it_is_english_language

	mov current_language_file_buffer_address,eax
	cmp current_language_file_buffer_address,0
	je @@exit_proc

	call Load_language_string, current_language_file_buffer_address, ebx, string_buffer_address, string_buffer_size

	cmp eax,0
	je @@load_string_eng
	jmp @@string_is_loaded_not_eng

@@load_string_eng:
	call LoadStringA, plugin_hInst, ebx, string_buffer_address, string_buffer_size

@@string_is_loaded_not_eng:
	push eax

	call GlobalFree, current_language_file_buffer_address

	pop eax
	mov current_language_file_buffer_address,0

	jmp @@exit_proc

@@exit_proc:
	ret

Plugin_text_strings endp


;---------------------------------------------

Load_language_string proc uses ebx ecx edx esi edi, language_file_buffer_address:dword, message_number:dword, \
	message_buffer_address:dword, message_buffer_length:dword

;       LNG-

;: language_file_buffer_address -  -      
;      message_number -         
;      message_buffer_address -      
;      message_buffer_length -       ,    
;      
;: eax=0 -   ,     eax=   (   )

.data?

number_string_buffer db 10 dup(?)

.code

	mov ebx,message_buffer_address
	mov byte ptr [ebx],0

	call Dword_to_string_asciiz, message_number, offset number_string_buffer

	call lstrlenA, offset number_string_buffer

	mov ebx,eax

	mov edi,offset number_string_buffer
	add edi,ebx
	mov word ptr [edi],"="
	inc ebx		;ebx           "="

	mov esi,language_file_buffer_address

	call lstrlenA, language_file_buffer_address

	mov ecx,eax	;ecx        
	cld

@@loop_search_crlf_and_number:
	cmp word ptr [esi],0A0Dh
	jne @@next_loop_search_crlf_and_number

	mov edx,esi
	mov eax,ecx
	mov ecx,ebx
	add esi,2

	mov edi,offset number_string_buffer

rep	cmpsb

	test ecx,ecx
	je @@string_found

	mov esi,edx
	mov ecx,eax

@@next_loop_search_crlf_and_number:
	inc esi
	dec ecx
	jnz @@loop_search_crlf_and_number

	mov eax,0		;     
	jmp @@exit_proc

@@string_found:
	mov edi,message_buffer_address
	mov ecx,message_buffer_length
	dec ecx 

@@loop_copy_message:
	cmp byte ptr [esi],0
	je @@exit_loop_copy_message
	cmp word ptr [esi],0A0Dh
	je @@exit_loop_copy_message
	cmp dword ptr [esi],"n\r\"	;\r\n
	jne @@copy_message_char

	mov word ptr [edi],0A0Dh	;     \r\n     CRLF (13,10  0D0Ah)
	add edi,2
	add esi,4
	sub ecx,3
	dec ecx
	jnz @@loop_copy_message

@@copy_message_char:
	movsb

	dec ecx
	jnz @@loop_copy_message

@@exit_loop_copy_message:
	mov byte ptr [edi],0
	mov eax,edi
	sub eax,message_buffer_address	;eax=   (   )

@@exit_proc:
	ret

Load_language_string endp

;---------------------------------------------

Open_language_file proc uses ebx ecx edx esi edi

local @@file_size:dword, @@current_ecx:dword, @@file_handle:dword, @@find_handle:dword

;      LNG-     

;: 0-  , <>0-       

.data

find_data_struct WIN32_FIND_DATA <0>
language_template_name db "\*.lng",0
plugin_name_in_language_file db "St Reader ZIP plugin-unpacker from St",0
lpFileSizeHigh dd 0
back_slash db "\",0
read_written_byte_number dd 0
local_language_code dd 0	;<>0        =0   

.data?

language_template_buffer db MAX_PATH dup(?)
language_file_buffer db MAX_PATH dup(?)
language_first_strings_buffer db 1024 dup(?)
current_language_buffer db 1024 dup(?)
current_language_file_path db MAX_PATH dup(?)

.code
	call lstrcpyA, offset language_template_buffer, Unpacker_Data_Struct.st_plugin_program_directory_address	

	call lstrcatA, offset language_template_buffer, offset language_template_name

; LNG-   
	call FindFirstFileA, offset language_template_buffer, offset find_data_struct

	cmp eax,INVALID_HANDLE_VALUE
	je @@set_english_current_language

	mov @@find_handle,eax

	jmp @@next_language_file_found

@@loop_count_languages_files:
	call FindNextFileA, @@find_handle, offset find_data_struct

	cmp eax,0
	jne @@next_language_file_found

	call FindClose, @@find_handle

	jmp @@set_english_current_language

@@next_language_file_found:
;LNG- 
;       LNG-
	call lstrcpyA, offset language_file_buffer, Unpacker_Data_Struct.st_plugin_program_directory_address

	call lstrcatA, offset language_file_buffer, offset back_slash

	lea eax,find_data_struct.cFileName

	call lstrcatA, offset language_file_buffer, eax

	call CreateFileA, eax, GENERIC_READ, FILE_SHARE_READ, L 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, L 0

	mov @@file_handle,eax

;  1024   LNG-      
	call ReadFile, eax, offset language_first_strings_buffer, 1024, offset read_written_byte_number, L 0

	call GetFileSize, @@file_handle, lpFileSizeHigh

	mov @@file_size,eax

	call CloseHandle, @@file_handle

	mov ecx,1024
	cmp ecx,@@file_size
	jbe @@file_size_less_then_selected_size

	mov ecx,@@file_size

@@file_size_less_then_selected_size:
	mov esi,offset language_first_strings_buffer
	mov edi,offset current_language_buffer

	cld

@@loop_get_program_name_from_file:
	cmp word ptr [esi],0A0Dh
	je @@exit_loop_get_program_name_from_file

	movsb

	loop @@loop_get_program_name_from_file

@@exit_loop_get_program_name_from_file:
	mov byte ptr [edi],0

	mov @@current_ecx,ecx

	call lstrcmpA, offset plugin_name_in_language_file, offset current_language_buffer

	cmp eax,0		;eax=0     LNG-     
	jne @@loop_count_languages_files

	mov ecx,@@current_ecx

	mov edi,offset current_language_buffer
	add esi,2

	cld

@@loop_get_language_name_from_file:
	cmp word ptr [esi],0A0Dh
	je @@exit_loop_get_language_name_from_file

	movsb

	loop @@loop_get_language_name_from_file

@@exit_loop_get_language_name_from_file:
	mov byte ptr [edi],0

	call lstrcmpiA, Unpacker_Data_Struct.st_plugin_language_name_address, offset current_language_buffer

	cmp eax,0		;eax=0       LNG-      (  )
	jne @@loop_count_languages_files

	call lstrcpyA, offset current_language_file_path, Unpacker_Data_Struct.st_plugin_program_directory_address

	call lstrcatA, offset current_language_file_path, offset back_slash

	lea eax,find_data_struct.cFileName

	call lstrcatA, offset current_language_file_path, eax

; LNG-         
	call CreateFileA, offset current_language_file_path, GENERIC_READ, FILE_SHARE_READ, L 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, L 0

	mov esi,eax

	call GetFileSize, esi, lpFileSizeHigh

	inc eax
	mov edi,eax

	call GlobalAlloc, GMEM_FIXED, edi

	mov ebx,eax

	call ReadFile, esi, eax, edi, offset read_written_byte_number, L 0

	add edi,ebx
	dec edi
	mov byte ptr [edi],0

	call CloseHandle, esi

	mov local_language_code,1	;LNG-          
	mov eax,ebx

	jmp exit_proc

@@set_english_current_language:
	mov eax,0
	mov local_language_code,0	;    LNG-     

	jmp exit_proc

exit_proc:
	ret

Open_language_file endp

;---------------------------------------------

Dword_to_string_asciiz proc uses ebx ecx edx edi, number:dword, address:dword
;     

;:  (32 ),  ASCIIZ      
;: eax=      

	mov ebx,10
	xor ecx,ecx
	mov edi,address
	mov eax,number

@@non_zero_decimal_digit:
	xor edx,edx
	div ebx
	push edx
	inc ecx
	or eax,eax
	jne @@non_zero_decimal_digit

@@digit_loop_decimal_digit:
	pop edx
	add dl,'0'
	mov [edi],dl
	inc edi
	dec ecx
	cmp ecx,0
	jne @@digit_loop_decimal_digit

	mov byte ptr [edi],0
	mov eax,address

	ret

Dword_to_string_asciiz endp

;+++++++++++++++++++++

String_asciiz_to_dword proc uses ebx edx esi, address:dword
;      (  )
;:  asciiz 
;: eax =   

	mov ebx,10
	mov eax,0
	mov esi,address

@@convert_decimal_digit:
	cmp byte ptr [esi],0
	je @@no_multiplication

	xor edx,edx
	mov dl,[esi]
	sub dl,'0'
	cmp dl,0
	jb @@error_not_decimal_digit
	cmp dl,9
	ja @@error_not_decimal_digit

	add eax,edx
	inc esi

	cmp byte ptr [esi],0
	je @@no_multiplication

	mul ebx

	jmp @@convert_decimal_digit

@@error_not_decimal_digit:
	inc esi
	jmp @@convert_decimal_digit

@@no_multiplication:
	ret

String_asciiz_to_dword endp

;+++++++++++++++++++++

Error_message proc uses ebx edi esi, parent_hwnd:dword, message_number:dword, alternative_string_address:dword, \
	insert_string_address1:dword, insert_string_address2:dword, insert_string_address3:dword, \
	message_title_number:dword, alternative_message_title_address:dword, message_style:dword

;     MessageBox

; parent_hwnd=-1  d  hwnd    0
; message_number=0     alternative_string_address,  alternative_string_address 
; message_title_number=0     alternative_message_title_address,  alternative_message_title_address 
;    #1, #2, #3    :
; #1 -    insert_string_address1,  #2 -   insert_string_address2,  #3 - 
;  insert_string_address3
; ## = #!!!!!


.data


.data?

ERROR_TITLE_BUFFER db MAX_PATH DUP(?)
ERROR_BUFFER DB 1025 DUP(?)
ERROR_BUFFER2 DB 1025 DUP(?)

.code

	cld	

	cmp message_title_number,0
	jne @@load_message_title_string

	call lstrcpyA, offset ERROR_TITLE_BUFFER, alternative_message_title_address

	jmp @@create_message_string

@@load_message_title_string:
	mov eax,Unpacker_Data_Struct.st_plugin_language_code_address
	cmp dword ptr [eax],0
	je @@load_title_string_from_resources

	call Open_language_file

	cmp local_language_code,0	;LNG-        
	je @@load_title_string_from_resources

	mov current_language_file_buffer_address,eax
	cmp current_language_file_buffer_address,0
	je @@load_title_string_from_resources

	call Load_language_string, current_language_file_buffer_address, message_title_number, OFFSET ERROR_TITLE_BUFFER, MAX_PATH

	cmp eax,0
	je @@load_title_string_from_resources
	jmp @@create_message_string

@@load_title_string_from_resources:
	call LoadStringA, plugin_hInst, message_title_number, offset ERROR_TITLE_BUFFER, MAX_PATH

@@create_message_string:
	mov esi,offset ERROR_BUFFER
	mov edi,offset ERROR_BUFFER2

	cmp message_number,0
	jne @@load_message_string
	
	mov esi,alternative_string_address
	jmp @@test_error_string

@@load_message_string:
	mov eax,Unpacker_Data_Struct.st_plugin_language_code_address
	cmp dword ptr [eax],0
	je @@load_string_from_resources
	cmp local_language_code,0	;LNG-        
	je @@load_string_from_resources

	call Load_language_string, current_language_file_buffer_address, message_number, OFFSET ERROR_BUFFER, 1024

	cmp eax,0
	je @@load_string_from_resources

	jmp @@test_error_string

@@load_string_from_resources:
	call LoadStringA, plugin_hInst, message_number, offset ERROR_BUFFER, 1024

@@test_error_string:
@@loop_search_insertion_points:
	cmp byte ptr [esi],0
	jne it_is_not_string_end

@@copy_zero_end_exit:
	movsb
	jmp @@exit_loop_search_insertion_points

it_is_not_string_end:
	cmp byte ptr [esi],"#"
	jne @@is_is_not_intertion_point

	inc esi

	cmp byte ptr [esi],0
	jne it_is_not_end_char

	jmp @@copy_zero_end_exit

it_is_not_end_char:
	cmp byte ptr [esi],"#"
	je @@it_is_number_sign

	mov ebx,insert_string_address1
	cmp byte ptr [esi],"1"
	je @@is_is_intertion_point

	mov ebx,insert_string_address2
	cmp byte ptr [esi],"2"
	je @@is_is_intertion_point

	mov ebx,insert_string_address3
	cmp byte ptr [esi],"3"
	je @@is_is_intertion_point
	jmp @@is_is_not_intertion_point

@@is_is_intertion_point:
	cmp ebx,0
	jne @@not_empty_inserting_string

	inc esi
	jmp @@empty_inserting_string
	
@@not_empty_inserting_string:
	mov eax,esi
	mov esi,ebx

@@loop_copy_insert_string:
	cmp byte ptr [esi],0
	je @@exit_loop_copy_insert_string

	movsb

	jmp @@loop_copy_insert_string

@@exit_loop_copy_insert_string:
	mov esi,eax
	inc esi
	jmp @@loop_search_insertion_points

@@it_is_number_sign:
@@is_is_not_intertion_point:
@@empty_inserting_string:
	movsb

	jmp @@loop_search_insertion_points

@@exit_loop_search_insertion_points:
	mov eax,parent_hwnd
	cmp eax,-1
	jne @@show_message

	mov eax,0		;   parent hwnd   =0

@@show_message:
	call MessageBoxA, eax, offset ERROR_BUFFER2, offset ERROR_TITLE_BUFFER, message_style

	call GlobalFree, current_language_file_buffer_address

	ret

Error_message endp 

;+++++++++++++++++++++

ends

end DLL_Entry